//
// 	area_level_graph.h
//

struct area_level_graph : public display_graph
{
public:
		area_level_graph(display_window*);
// database updates
	virtual	void	read_from_database();
	virtual void	write_to_database();
	virtual	void	input(int,int,int);
	virtual	void	output(int,int);
	virtual void	print(ostream&);
	virtual void	display();
};

class area_level_graph_par : public area_level_graph
{
public:
		area_level_graph_par(display_window*,nsl_data*);
// database updates
	void	read_from_database();
	void	write_to_database();

	void	print(ostream&);
	void	display();
	void	input(int,int,int);
	void	output(int,int);
};
class area_level_graph_vec : public area_level_graph
{
	int i0,i1;		// vector range
	int imax;		// vector size
	int vec_type;		// 0 - row vector, 1 - col vector
public:
		area_level_graph_vec(display_window*,nsl_vector*);
// database updates
	void	read_from_database();
	void	write_to_database();

	void	print(ostream&);
	void	display();
	void	input(int,int,int);
	void	output(int,int);
};
class area_level_graph_mat : public area_level_graph 
{
	int i0,i1;		// row range
	int j0,j1;		// col range
	int imax,jmax;		// matrix size
public:
		area_level_graph_mat(display_window*,nsl_matrix*);
// database updates
	void	read_from_database();
	void	write_to_database();

	void	print(ostream&);
	void	display();
	void	input(int,int,int);
	void	output(int,int);
};
