//
// 	display_canvas.h
//
// 95-1-31 aa took out extern
class display_frame;

class display_canvas : public generic_window
{
	Canvas canvas;				// sunview handle
	display_frame* parent_frame;		// parent frame
	display_window* parent_window;		// parent window

	display_graph*	canvas_graph;		// graphics
	int clear_fg;				// clear graphics

	int object_total;			// object total
	canvas_type_list* graph_objects;	// display objects

	int redraw_fg;				// 1 - redraw all objects
	// temporary variables
	int loc_fg;				// 1 - top, 0 - bottom
	int label_top_x_loc,label_bot_x_loc;	// canvas drawing
	int label_top_y_loc,label_bot_y_loc;	// canvas drawing
public:
		display_canvas(display_frame*,display_window*,char*);
		~display_canvas();

	Canvas	get_canvas() { return canvas; }
	display_frame*	get_parent_frame() { return parent_frame; }
	display_window*	get_parent_window() { return parent_window; }

	display_graph*	get_canvas_graph() { return canvas_graph; }
	void	set_canvas_graph(display_graph* graph) { canvas_graph=graph; }

	canvas_type_list* get_graph_objects() { return graph_objects; }

	void	set_object_total(int i) { object_total = i; }
	int 	get_object_total() { return object_total; }
	canvas_type_list* get_object_list() { return graph_objects; }

	canvas_object* get_canvas_item(int);
	canvas_object* get_canvas_item(char*);

	int 	get_redraw_fg() { return redraw_fg; }
	void 	set_redraw_fg(int i) { redraw_fg = i; }

	int 	get_clear_fg() { return clear_fg; }
	void 	set_clear_fg(int i) { clear_fg = i; }

	int 	get_loc_fg() { return loc_fg; }
	void 	set_loc_fg(int i) { loc_fg = i; }

// resize canvas
	void	resize(int,int,int,int); 
// init canvas objects
	void	reset();
	void	reset_data();	
	void	init();	
	void	init_data();	
	void	set_data();	
// create canvas 
	void	create();
	void	create(int,int,int,int); 
// read from database and display
	void	update();
// clear canvas
	void	clear();
// enable 
	void enable_item(int);
	void enable_item(char*);
	void enable_all_item();
// disable
	void disable_item(int);
	void disable_item(char*);
	void disable_all_item();

// init window top and bottom labels
	int	init_win_label(char*,char*,int);
	int	init_win_label(char*,int);
	int	set_win_label(char*);
// init window lines
	void	init_win_line(float);
	void	init_win_line(float,float);
// init window grid
	void	init_win_grid();
	void	init_win_grid(int);
// init graphics
	// init area level graph
	void	init_area_level_graph(nsl_layer*,int);
	void	init_area_level_graph(nsl_data*);
	void	init_area_level_graph(nsl_vector*);
	void	init_area_level_graph(nsl_matrix*);
	// init spatial graph 2
	void	init_spatial_graph_2(nsl_layer*,int);
	void	init_spatial_graph_2(nsl_data*);
	void	init_spatial_graph_2(nsl_vector*);
	void	init_spatial_graph_2(nsl_matrix*);
	// init spatial graph 3
	void	init_spatial_graph_3(nsl_layer*,int);
	void	init_spatial_graph_3(nsl_data*);
	void	init_spatial_graph_3(nsl_vector*);
	void	init_spatial_graph_3(nsl_matrix*);
	// init temporal graph
	void	init_temporal_graph(nsl_layer*,int);
	void	init_temporal_graph(nsl_data*);
	void	init_temporal_graph(nsl_vector*);
	void	init_temporal_graph(nsl_matrix*);
	// init user graph 
//	void	init_user_graph(nsl_layer*,int);
//	void	init_user_graph(nsl_data*);
//	void	init_user_graph(nsl_vector*);
//	void	init_user_graph(nsl_matrix*);
// database updates
	void	read_from_database();
	void	write_to_database();
// display
	void	display();
// mouse input
	void	input(int,int,int);
	void	output(int,int);	
// print canvas objects
	void	print_status(ostream&);
	void	print_all_item_status(ostream&);
	void	print_item_status(ostream&,int);
	void	print_item_status(ostream&,char*);
};

