//
// 	display_window.h
//

class display_window : public generic_window
{
	display_frame* parent_frame;		// parent display frame

	display_canvas* window_canvas;		// window canvas
	display_panel* control_panel;		// control panel

// window main (name,layer,graph)
	int main_total;				// main total

	string	graph_name;			// graph name
	int graph_type;

	string	layer_name;			// layer name
	int layer_type;
	nsl_layer* layer;			// layer object	

// window data		
	int data_total;				// data total
	data_type_list* data_list; 		// data base

public:
		display_window(display_frame*,char*);
		~display_window();

	display_canvas* get_window_canvas() { return window_canvas; }
	display_panel* get_control_panel() { return control_panel; }

	int 	get_main_total() { return main_total; }

	int 	get_data_total() { return data_total; }
	data_type_list* get_data_list() { return data_list; }

	void 	set_layer_type(int i) { layer_type = i; }
	void 	set_graph_type(int i) { graph_type = i; }
	void	set_graph_name(char* str) { strcpy(graph_name,str); }
	void	set_layer_name(char* str) { strcpy(layer_name,str); }
	void	set_layer(nsl_layer* ptr) { layer = ptr; }

	int 	get_layer_type() { return layer_type; }
	int 	get_graph_type() { return graph_type; }
	char*	get_graph_name() { return graph_name; }
	char* 	get_layer_name() { return layer_name; }
	nsl_layer* get_layer() { return layer; }

	void 	update_window_layer(); // set layer_name first
	void	update_window_graph(); // set graph_name first
	void 	update_window_layer(char*); // set layer_name first
	void	update_window_graph(char*); // set graph_name first

// resize canvas window, data frame, data panel
	void	resize(int,int,int,int); 
// create canvas window, data frame, data panel
	void	create();		
	void	create(int,int,int,int); 
// init window database
	void	reset();	// reset all window lists
	void	reset_main();	// reset layer and graph
	void	reset_data();	// reset window lists
	void	reset_data_list(); // reset window lists, layer and graph	
	void	init();		// init window data
	void	init_main();	// init main window data
	void	init_data();	// init window data
	void	set_data();	// set window data
// init database entry
	int	init_general_data(char*,int); 	// return data index number
	int	init_general_data(char*,int,int); // return data index number
// set database entry value
	int	set_general_data(char*,char*,int); // return data index number
	int	set_general_data(char*,char*); // return data index number
	int	set_general_data(char*,float); // return data index number
	int	set_general_data(char*,int);   // return data index number
// get database entry value
	int	get_general_data(char*,char*); // return data index number
	int	get_general_data(char*,float*); // return data index number
	int	get_general_data(char*,int*);   // return data index number
// get data obj
	nsl_data*	get_window_data(char*);   // return data by name
	nsl_data*	get_window_data(int);   // return data by index

// get database data type
	int	get_general_data_type(char*);   // return data type
// set database display area
	void	set_win_sector();
	void	set_win_sector(int,int,int,int,int,int);

	void	clear();

// update
	void	update();
	void	update_from_panel();

	void	read_from_database(); 	// read data
	void	write_to_database();	// write data
	void	display();
// mouse input
	void	input(int,int,int);
	void	output(int,int);		
	
// print window data
	void	print_status(ostream&);
	void	print_all_item_status(ostream&);
	void	print_item_status(ostream&,int);
	void	print_item_status(ostream&,char*);

	void	print_canvas_status(ostream&);
	void	print_panel_status(ostream&);
};

