/**************************************************************/
/*                                                            */
/*                       nsl_buffer.h 		              */
/*                                                            */
/* by Alfredo Weitzenfeld 				      */
/*                                                            */
/**************************************************************/

//static char SccsId[] = "%W%  %G%"; /* SCCS */

struct nsl_buffer
{
	strstream* stream;	// string stream
	strstreambuf* sb;	// stream buffer
	string out_str;		// holds current output string 
	int able_fg;		// 0 - off, 1 - on
	int str_cnt;		// total string count
	int xn_cnt;		// xn num count
	int yn_cnt;		// yn num count
	int size_cnt;		// xn*yn (total size) num count
	int cmd_cnt;		// total_cnt - size_cnt
	
public:
		nsl_buffer();
		~nsl_buffer();

	void enable() { able_fg = 1; }
	void disable() { able_fg = 0; }
	void set_able_fg(int i) { able_fg = i; }
	int  get_able_fg() { return able_fg; }

	void reset_stream();
	void rewind_stream();

	strstream* get_stream() { return stream; }

	void  set_out_str(char* str) { strcpy(out_str,str); }
	char* get_out_str() { return out_str; }

	void reset_all_cnt()
	{ str_cnt = 0; xn_cnt = 0; yn_cnt = 0; size_cnt = 0; cmd_cnt = 0; }

	void reset_str_cnt() { str_cnt = 0; }
	void set_str_cnt(int i) { str_cnt = i; }
	int incr_str_cnt() { return ++str_cnt; }
	int decr_str_cnt() { return --str_cnt; }
	int incr_str_cnt(int i) { return (str_cnt += i); }
	int decr_str_cnt(int i) { return (str_cnt -= i); }
	int get_str_cnt() { return str_cnt; }

	void reset_xn_cnt() { xn_cnt = 0; }
	void set_xn_cnt(int i) { xn_cnt = i; }
	int incr_xn_cnt() { return ++xn_cnt; }
	int decr_xn_cnt() { return --xn_cnt; }
	int incr_xn_cnt(int i) { return (xn_cnt += i); }
	int decr_xn_cnt(int i) { return (xn_cnt -= i); }
	int get_xn_cnt() { return xn_cnt; }

	void reset_yn_cnt() { yn_cnt = 0; }
	void set_yn_cnt(int i) { yn_cnt = i; }
	int incr_yn_cnt() { return ++yn_cnt; }
	int decr_yn_cnt() { return --yn_cnt; }
	int incr_yn_cnt(int i) { return (yn_cnt += i); }
	int decr_yn_cnt(int i) { return (yn_cnt -= i); }
	int get_yn_cnt() { return yn_cnt; }

	void reset_size_cnt() { size_cnt = 0; }
	void set_size_cnt(int i) { size_cnt = i; }
	int incr_size_cnt() { return ++size_cnt; }
	int decr_size_cnt() { return --size_cnt; }
	int incr_size_cnt(int i) { return (size_cnt += i); }
	int decr_size_cnt(int i) { return (size_cnt -= i); }
	int get_size_cnt() { return size_cnt; }

	void reset_cmd_cnt() { cmd_cnt = 0; }
	void set_cmd_cnt(int i) { cmd_cnt = i; }
	int incr_cmd_cnt() { return ++cmd_cnt; }
	int decr_cmd_cnt() { return --cmd_cnt; }
	int incr_cmd_cnt(int i) { return (cmd_cnt += i); }
	int decr_cmd_cnt(int i) { return (cmd_cnt -= i); }
	int get_cmd_cnt() { return cmd_cnt; }

	istream& operator>>(char*);
	istream& operator>>(nsl_layer&);
	istream& operator>>(nsl_layer*);
	istream& operator>>(float&);
	istream& operator>>(int&);

	ostream& operator<<(char*);
	ostream& operator<<(nsl_layer&);
	ostream& operator<<(nsl_layer*);
	ostream& operator<<(float);
	ostream& operator<<(int);

	istream& operator>>(ostream&);

	void print_status(ostream&);
};



