//
//	nsl_input_vector.h
//

// input vector
class nsl_input_vector : public nsl_vector
{
	int xz;			// matrix zero elements
	float dx;			// adjacent elem distance
//	float erf;              	// erf - excit. receptive field (dia)
	int overlap_fg;			// overlap
	int stim_total;			// stim list total
	nsl_stim_list* stim_list;	// stim list

public:

	nsl_input_vector(char*,int);
	~nsl_input_vector();

// set
	void	set_stim_list(nsl_stim_list* l) { stim_list = l; }
	void	set_overlapfg(int i) { overlap_fg = i; }
	void	set_xz(int i) { xz = i; }
	void	set_dx(float s) { dx = s; }
// get
	nsl_stim_list*	get_stim_list() { return stim_list; }
	nsl_stim_obj* get_stim(int);
	nsl_stim_obj* get_stim(char*);
	int	get_stim_total() { return stim_total; }
	int	get_overlapfg() { return overlap_fg; }
	int	get_xz() { return xz; }
	float	get_dx() { return dx; }

// 	assignment
void 	operator=(nsl_input_vector&);
void 	operator=(nsl_vector&);
void 	operator=(nsl_data&);
// void 	operator=(num_type*);
void 	operator=(num_type);

	void clear_stim();
	void copy_stim(nsl_input_vector&);

	nsl_block_vector* init_block_stim();
	nsl_icon_vector* init_icon_stim();

	void run();

// print status
	void print_status(ostream&); // virtual
	void print_layer_status(ostream&); // local

	void print_stim(ostream&);
	void print_stim(ostream&,int);
};

typedef nsl_input_vector NSL_INPUT_VECTOR;
