//
//	nsl_layer.h
//

// 96-1-26 aa took out extern
class nsl_stim_obj;

struct nsl_layer
{
	char name[NAME_SIZE];
	int index;
	int layer_type;	// 1 - nsl_data, 2 - nsl_vector, 3 - nsl_matrix
	int h_type; // 0 - layer, 1 - input layer
	int able_fg; // 1 - process layer, 0 - otherwise
public:
		nsl_layer(int);
		nsl_layer(char*,int);
// set
	void 	set_name(char* str) { strcpy(name,str); }
	void 	set_index(int i) { index = i; }
	void 	set_layer_type(int i) { layer_type = i; }
	void 	set_h_type(int i) { h_type = i; }
	void 	set_able_fg(int i) { able_fg = i; }
// get
	char* 	get_name() { return name; }
	int 	get_index() { return index; }
	int 	get_layer_type() { return layer_type; }
	int 	get_h_type() { return h_type; }
	int 	get_able_fg() { return able_fg; }

// enable, disable
	void 	enable() { able_fg = 1; }
	void 	disable() { able_fg = 0; }

// operator '='
	void 	operator=(nsl_layer&);
	void 	operator=(num_type);
	void 	operator=(int);

	// print
friend	ostream& 	operator<<(ostream&,nsl_layer&);
friend	istream& 	operator>>(istream&,nsl_layer&);

// virtual: 
	virtual void print(ostream&) {}
	virtual void print_status(ostream&) {}
		void print_layer_status(ostream&);
	virtual void print_stim(ostream&) {} 		// print all stim
	virtual void print_stim(ostream&,int) {} 	// print indexed stim

	virtual nsl_stim_obj* get_stim(int) { return (nsl_stim_obj*) 0; }
	virtual nsl_stim_obj* get_stim(char*) { return (nsl_stim_obj*) 0; }
};

// layer list 
typedef nsl_layer* layer_obj_ptr;
declare(gslist,layer_obj_ptr);

typedef gslist_iterator(layer_obj_ptr) layer_obj_iterator;
typedef gslist(layer_obj_ptr) layer_obj_list;
