//
//	gen_list.c
//

# include "nsl.h"

// last->next points to head element

int slist::insert(ent a) // push element
{
	if (last)
		last->next = new slink(a,last->next);
	else
	{
		last = new slink(a,0);
		last->next = last;
	}
	return 0;
}

int slist::append(ent a) // append element
{
	if (last)
		last = last->next = new slink(a,last->next);
	else
	{
		last = new slink(a,0);
		last->next = last;
	}
	return 0;
}

ent slist::get() // pop element
{
	if (last == 0)
		cmd_error_exit("get from empty list");
//		slist_handler("get from empty list");//p.205
	slink* f = last->next;
	ent r = f->e;
	if (f == last)
		last = 0;
	else
		last->next = f->next;
	delete f;
	return r;
}

void slist::clear() // clear all elements
{
	slink* l = last;
	if (l == 0)
		return;
	do
	{
		slink* ll = l;
		l = l->next;
		delete ll;
	} 
	while (l != last);
}
void slist::clear(int i1,int i2) // truncate after first i1
{
	slink* l = last;
	int i = 0;

	if (l == 0)
		return;

	slink* first = last->next;

//	cout << "clear: " << i1 << "," << i2 << "\n";

	do // iterate i1 elements
	{
		l = l->next;
		i++;
//		cout << i << "\n";
	} 
	while (i < i1 && l != last);

	if (l == last)
		return;

// only i1 elements, w/ last pointing back to the beginning
	last = l;
	last->next = first;

/*	slink* last0 = l;

	i = 0;
	do // delete i2 elements
	{
		slink* ll = l;
		l = l->next;
		delete ll;
		i++;
		cout << i << "\n";
	} 
	while (i < i2 && l != last);

	last = last0;
*/
	cout.flush();
}
void slist::print() // print all elements
{
	int i=0;
	slink* l = last;
	if (l == 0)
		return;
	cout << "START\n";
	do
	{
	  cout<<++i<<"  slist  "<<l->e<<"\n";  // dj
		l = l->next;
//		cout << ++i << "\n";
	} 
	while (l != last);
	cout << "END\n";
	cout.flush();
}
