/*                                                            	*/
/*                       graph_winds.c                        	*/
/*                                                            	*/
/* by Alfredo Weitzenfeld				      	*/
/*                                                            	*/
/****************************************************************/
/* this program has been changed to Xview pragram by Longguang  */
/****************************************************************/
static char SccsId[] = "%W%  %G%"; /* SCCS */

# include <stdio.h> 
# include <math.h>
# include <signal.h>
/* b 95/6/22 aa */
# include <memory.h>
/* e 95/6/22 aa */

/* below source code for raster dumps */

# include <X11/Xos.h>
# include <X11/cursorfont.h>
# include <X11/Xatom.h>
# include <X11/XWDFile.h>
# include <X11/keysym.h>
/* # include "patchlevel.h" */

# ifndef CARD32
# include <X11/Xmd.h>
/* extern "C" notify_set_signal_func();*/
/*
The following comes from X11/Xutil.h but the rest of the file 
needs to be converted to C++
*/
#define XGetPixel(ximage, x, y) \
        ((*((ximage)->f.get_pixel))((ximage), (x), (y)))
# endif
/* above source code for raster dumps */

typedef float num_type;

# define NAME_SIZE 80
typedef char string[NAME_SIZE];

# include "sun_winds.h"

# define PIX_XOR (PIX_SRC ^ PIX_DST)
# define C_PIX_SRC (PIX_NOT(PIX_SRC))
# define C_PIX_DST (PIX_NOT(PIX_DST))

static unsigned int FONT_DX = 8;
static unsigned int FONT_DY = 12;

// AA: 95/11/6 changed to long
#if defined(__nsl_osver)
extern "C" long fork();
#else 
//extern "C" int fork();  6/96 dj
#endif

/* 95/6/22 aa initiailized BREAKFG =0;*/
int BREAKFG =0;

/* source code for raster dumps */
/* XWD format image file */
typedef unsigned char byte;
typedef unsigned long dw;
typedef unsigned int  word;

#define MAX_CELLS  256
#define TRUE  1
#define FALSE 0

typedef struct {
  XImage *ximage;
  word numcells;
  word red[MAX_CELLS], green[MAX_CELLS], blue[MAX_CELLS];
  byte used[MAX_CELLS];
} imageInfo;

int save_pixwin_to_raster_from_file(Frame frame,char * fname)
{
	XWDFileHeader *header;

	int hScreen, ncolors, cmapSize, numCmaps;
	Display *hDisplay;
	Window win,hRoot;
	unsigned int width, height,depth,x,y;
	int  j;
	FILE *outfile;
   	imageInfo *image; 
        int nc,w, h, cidx, cpp;
        char mne[MAX_CELLS][3];
	dw visMask;
	Visual *visual;
        char *imageName = fname;
        XColor *color;
	XColor colors[MAX_CELLS];
	long i;
        Colormap *cmaps;
	Colormap cmap;
	int verbose = TRUE;

	color = (XColor *)malloc(sizeof(XColor));
	header = (XWDFileHeader *)malloc(sizeof(XWDFileHeader));
	image = (imageInfo *)malloc(sizeof(imageInfo));
	image->ximage = (XImage *)malloc(sizeof(XImage));
	hDisplay = (Display *)XOpenDisplay(0);
	win = (Window)xv_get(frame,XV_XID);
        hScreen  = DefaultScreen(hDisplay);
        hRoot    = DefaultRootWindow(hDisplay);
	depth = DefaultDepth(hDisplay,hScreen);
	
	visual = DefaultVisual(hDisplay,hScreen);
	visMask = (visual->red_mask
			| visual->green_mask
			| visual->blue_mask);

	XGrabServer(hDisplay);
	if ((outfile = fopen(fname,"w")) == NULL)
		fprintf(stderr,"Cannot open file: %s\n",fname);
	else
	{
	    width  = (int)xv_get(frame,XV_WIDTH);
	    height = (int)xv_get(frame,XV_HEIGHT);

	    image->ximage = XGetImage(hDisplay,win,0,0,
		width,height,AllPlanes,depth==1 ? XYPixmap : ZPixmap);
	
 	    cmaps = XListInstalledColormaps(hDisplay, win, &numCmaps);
  	    if (numCmaps == 0)
    		cmap = DefaultColormap(hDisplay, hScreen);
  	    else 
	    {
    		cmap = *cmaps;
    		if (numCmaps > 1)
      		    fprintf(stderr,"%s: more than one colormap found: ",fname);
 	    }
  	    /* XFree(cmaps); 95/6/21 aa */
	    XFreeColormap(hDisplay, *cmaps);

  	    ncolors = DisplayCells(hDisplay, hScreen);
 
   	    for (i=0; i<ncolors; i++)
    		colors[i].pixel = i;
      
  	    XQueryColors(hDisplay, cmap, colors, ncolors);
  	    for (i=0; i<ncolors; i++) 
	    {
   	 	image->red[i]   = colors[i].red;
    		image->green[i] = colors[i].green;
    		image->blue[i]  = colors[i].blue; 
  	    } 

  	    ncolors = cmapSize = 0;
  	    memset(image->used, 0, MAX_CELLS);
  	    for (h=0; h<image->ximage->height; h++)
    		for (w=0; w<image->ximage->width; w++) 
		{
      		    i = XGetPixel(image->ximage, w, h);
      		    if (!image->used[i]) 
		    {
        		image->used[i] = TRUE;
       			if (i+1 > cmapSize)
			    /* 95/6/21 aa casting */
          		    cmapSize = (int)i+1;
        		ncolors++;
     		    }
    		}
	   image->numcells = cmapSize;
/*  if (verbose)
    fprintf(stderr, "%s: image has %d colors\n", fname, ncolors); */
 	   XCloseDisplay(hDisplay);

/* if (verbose)
    fprintf(stderr, "%s: formatting xwd output\n", fname); */

  header->header_size    = (CARD32)(sizeof(XWDFileHeader)+strlen(imageName)+1);
  header->file_version   = (CARD32) XWD_FILE_VERSION;
  header->pixmap_format  = (CARD32)(image->ximage->depth>1? ZPixmap : XYPixmap);
  header->pixmap_depth   = (CARD32) image->ximage->depth;
  header->pixmap_width   = (CARD32) image->ximage->width;
  header->pixmap_height  = (CARD32) image->ximage->height;
  header->xoffset        = (CARD32) image->ximage->xoffset;
  header->byte_order     = (CARD32) image->ximage->byte_order;
  header->bitmap_unit    = (CARD32) image->ximage->bitmap_unit;
  header->bitmap_bit_order = (CARD32) image->ximage->bitmap_bit_order;
  header->bitmap_pad     = (CARD32) image->ximage->bitmap_pad;
  header->bits_per_pixel = (CARD32) image->ximage->bits_per_pixel;
  header->bytes_per_line = (CARD32) image->ximage->bytes_per_line;
#if defined(__cplusplus) || defined(c_plusplus)
  header->visual_class   = (CARD32) visual->c_class; /* C++ class of screen (monochrome, etc.) */
#else
  header->visual_class   = (CARD32) visual->class; /* class of screen (monochrome, etc.) */
#endif
  header->red_mask       = (CARD32) visual->red_mask;
  header->green_mask     = (CARD32) visual->green_mask;
  header->blue_mask      = (CARD32) visual->blue_mask;
  header->bits_per_rgb   = (CARD32) visual->bits_per_rgb;
  header->colormap_entries = (CARD32) visual->map_entries;
  header->ncolors        = image->numcells;
  header->window_width   = (CARD32) image->ximage->width;
  header->window_height  = (CARD32) image->ximage->height;
  header->window_x       = 0;
  header->window_y       = 0;
  header->window_bdrwidth = 0;

  fwrite((char *)header, sizeof(XWDFileHeader), 1, outfile);
  fwrite((char *)imageName, 1, strlen(imageName)+1, outfile);

  for (j=0; j<image->numcells; j++) 
  {
    color->pixel = j;
    color->red   = image->red[j];
    color->green = image->green[j];
    color->blue  = image->blue[j];
    color->flags = visMask;
    color->pad   = 0;
    /* 95/6/21 aa casting */
    fwrite((char *)color, sizeof(XColor), 1, outfile);
  }
     fwrite(image->ximage->data,
  	image->ximage->height*image->ximage->bytes_per_line,
	1, outfile);
     fclose(outfile);
  }
	return 1;
}


Notify_value interrupt_handler()     /* HANDLER traps interrupt '^C' */
{
        BREAKFG = 1;
/*   	signal(SIGINT,interrupt_handler);*/

	return NOTIFY_DONE;
}
Notify_value urgent_handler()     /* HANDLER traps interrupt 'L1' (STOP) */
{
        BREAKFG = 1;
/*      signal(SIGURG,urgent_handler);*/

	return NOTIFY_DONE;
}
void init_nsl_interrupt_handler()
{
	notify_set_signal_func((Notify_client)1111, interrupt_handler, SIGINT, NOTIFY_ASYNC);

/*	signal(SIGINT,interrupt_handler); */	/* SIGINT '^C' */
/*	signal(SIGURG,urgent_handler); 	*/	/* SIGURG 'L1' (STOP) */
}

/* draw canvas using Xlib */

int pw_clear_area_level(Canvas canvas,Xv_Window pw,int wx0,int wy0,int wxs,int wys)
{
	int wxc,wyc,height;
	Frame frame;
	Display  *dpy;
	Window  xwin;
	Xv_xrectlist *xrects;
	GC gc;

	xwin = (Window)xv_get(canvas_paint_window(canvas),XV_XID);
	frame = (Frame)xv_get(canvas, XV_OWNER);
	dpy = (Display *)xv_get(frame, XV_DISPLAY);
	xrects = (Xv_xrectlist *)xv_get(canvas,CANVAS_VIEWABLE_RECT,pw);
	gc = DefaultGC(dpy, DefaultScreen(dpy));
	height = (int) xv_get(canvas, CANVAS_HEIGHT);

	if (wxs-1 <= 0 && wys-1 <= 0)
	{
		printf("Unable to draw");
		return 1;
	}

	XClearArea(dpy,xwin,wx0+1,wy0+1,wxs-1,wys-1,FALSE);
	return 0;
}

int clear_area_level(Canvas canvas,int wx0,int wy0,int wxs,int wys)
{
	Xv_Window pw;
	
	pw = canvas_paint_window(canvas);
	pw_clear_area_level(canvas,pw,wx0,wy0,wxs,wys);
	return 1;
}

int pw_area_level_val(Canvas canvas,Xv_Window pw,int wx0,int wy0,int wxs,int wys,num_type val,num_type vmin,num_type vmax)
{
	int wxc,wyc,i0,j0,ic,jc,height;
	num_type s;
	Frame frame;
	Display  *dpy;
	Window  xwin;
	Xv_xrectlist *xrects;
	GC gc;

	xwin = (Window)xv_get(canvas_paint_window(canvas),XV_XID);
	frame = (Frame)xv_get(canvas, XV_OWNER);
	dpy = (Display *)xv_get(frame, XV_DISPLAY);
	xrects = (Xv_xrectlist *)xv_get(canvas,CANVAS_VIEWABLE_RECT,pw);
	gc = DefaultGC(dpy, DefaultScreen(dpy));
	height = (int) xv_get(canvas, CANVAS_HEIGHT);

	if (wxs-1 <= 0 && wys-1 <= 0)
	{
		printf("Unable to draw");
		return 1;
	}

/*	if (val == 0)*/
	    XClearArea(dpy,xwin,wx0+1,wy0+1,wxs-1,wys-1,FALSE);
/*	else*/
	{

	    if (vmin > 0.0)
		vmin = 0.0;
	    if (vmax < 0.0)
		vmax = 0.0;
	    if (vmin == 0.0 && vmax == 0.0)
		vmax = 1.0;

	    if ((val>=vmax && vmax > 0.0) || (val<=vmin && vmin < 0.0))
	    {
		wxc = wxs;
		wyc = wys;
	    }
	    else
	    {
	    	s = 0.0;
		if (val > 0.0 && vmax > 0.0)
	    	    s = val/vmax;
		else if (val < 0.0 && vmin < 0.0)
		    s = val/vmin;

	    	wxc = (int)rint(s*wxs);  /* 95/6/21 aa - put in casting for sparc CC compiler*/
	    	wyc = (int)rint(s*wys);
	    }
	    ic = (wxs - wxc)/2;
	    jc = (wys - wyc)/2;
	    i0 = ic + wx0 + 1;
	    j0 = jc + wy0 + 1;
	    if (wxc-1 > 0 && wyc-1 > 0)
            	XFillRectangle(dpy,xwin,gc,i0,j0,wxc-1,wyc-1);
	    if (val < 0.0)
	    {
		if (wxc-3 > 0 && wyc-3 > 0)
            	   XClearArea(dpy,xwin,i0+1,j0+1,wxc-3,wyc-3,FALSE);
	    }
	}
	return 0;
} 

int draw_area_level_val(Canvas canvas,int wx0,int wy0,int wxs,int wys,num_type val,num_type vmin,num_type vmax)
{
	Xv_Window pw;
	
	pw = canvas_paint_window(canvas);
	pw_area_level_val(canvas,pw,wx0,wy0,wxs,wys,val,vmin,vmax);
	return 1;
}

int draw_point(Canvas canvas,int x,int y)
{
	Frame frame;
	Xv_Window pw;
	Display  *dpy;
	Window  xwin;
	Xv_xrectlist *xrects;
	int height;
	GC gc;


	pw = canvas_paint_window(canvas);
	xwin = (Window)xv_get(canvas_paint_window(canvas),XV_XID);
	frame = (Frame)xv_get(canvas, XV_OWNER);
	dpy = (Display *)xv_get(frame, XV_DISPLAY);
	xrects = (Xv_xrectlist *)xv_get(canvas,CANVAS_VIEWABLE_RECT,pw);
	gc = DefaultGC(dpy, DefaultScreen(dpy));
	height = (int) xv_get(canvas, CANVAS_HEIGHT);

	XDrawPoint(dpy,xwin,gc,x,height-y);
	return 1;
} 
int draw_line(Canvas canvas,int x0,int y0,int x1,int y1)
{

	Frame frame;
	Xv_Window pw;
	Display  *dpy;
	Window  xwin;
	Xv_xrectlist *xrects;
	int height;
	GC gc;

	pw = canvas_paint_window(canvas);
	xwin = (Window)xv_get(canvas_paint_window(canvas),XV_XID);
	frame = (Frame)xv_get(canvas, XV_OWNER);
	dpy = (Display *)xv_get(frame, XV_DISPLAY);
	xrects = (Xv_xrectlist *)xv_get(canvas,CANVAS_VIEWABLE_RECT,pw);
	gc = DefaultGC(dpy, DefaultScreen(dpy));
	height = (int) xv_get(canvas, CANVAS_HEIGHT);
	y0 = height - y0;
	y1 = height - y1;

	XDrawLine(dpy,xwin,gc,x0,y0,x1,y1);
	return 1;
} 
int draw_horizontal_broken_line(Canvas canvas,int x0,int x1,int y)
{
	Frame frame;
	Xv_Window pw;
	Display  *dpy;
	Window  xwin;
	Xv_xrectlist *xrects;
	int height,x,xs,xm;
	GC gc;

	pw = canvas_paint_window(canvas);
	xwin = (Window)xv_get(canvas_paint_window(canvas),XV_XID);
	frame = (Frame)xv_get(canvas, XV_OWNER);
	dpy = (Display *)xv_get(frame, XV_DISPLAY);
	xrects = (Xv_xrectlist *)xv_get(canvas,CANVAS_VIEWABLE_RECT,pw);
	gc = DefaultGC(dpy, DefaultScreen(dpy));
	height = (int) xv_get(canvas, CANVAS_HEIGHT);
	xs = 5; 
	xm = 3; 
	for (x = x0; x < x1 - xs; x = x + xs)	
		XDrawLine(dpy,xwin,gc,x,height-y,x+xm,height-y);
	XDrawLine(dpy,xwin,gc,x,height-y,x1,height-y);
	return 1;
} 

int draw_vertical_broken_line(Canvas canvas,int x,int y0,int y1)
{
	Frame frame;
	Xv_Window pw;
	Display  *dpy;
	Window  xwin;
	Xv_xrectlist *xrects;
	int height,y,ys,ym;
	GC gc;

	pw = canvas_paint_window(canvas);
	xwin = (Window)xv_get(canvas_paint_window(canvas),XV_XID);
	frame = (Frame)xv_get(canvas, XV_OWNER);
	dpy = (Display *)xv_get(frame, XV_DISPLAY);
	xrects = (Xv_xrectlist *)xv_get(canvas,CANVAS_VIEWABLE_RECT,pw);
	gc = DefaultGC(dpy, DefaultScreen(dpy));
	height = (int) xv_get(canvas, CANVAS_HEIGHT);
	ys = 5; 
	ym = 3; 

	for (y = y0; y < y1 - ys; y = y + ys)
		XDrawLine(dpy,xwin,gc,x,height-y,x,height-y-ys);
	XDrawLine(dpy,xwin,gc,x,height-y,x,height-y1);
	return 1;
} 
int draw_slanted_broken_line(Canvas canvas,int x0,int x1,int y0,int y1)
{
	Frame frame;
	Xv_Window pw;
	Display  *dpy;
	Window  xwin;
	Xv_xrectlist *xrects;
	int x,xs,xm,y,ys,ym,height;
	GC gc;

	pw = canvas_paint_window(canvas);
	xwin = (Window)xv_get(canvas_paint_window(canvas),XV_XID);
	frame = (Frame)xv_get(canvas, XV_OWNER);
	dpy = (Display *)xv_get(frame, XV_DISPLAY);
	xrects = (Xv_xrectlist *)xv_get(canvas,CANVAS_VIEWABLE_RECT,pw);
	gc = DefaultGC(dpy, DefaultScreen(dpy));
	height = (int) xv_get(canvas, CANVAS_HEIGHT);
	xs = 5; 
	xm = 3; 
	ys = xs*(y1-y0)/(x1-x0);
	ym = xm*(y1-y0)/(x1-x0);

	for (x = x0,y = y0; x < x1 - xs; x = x + xs, y = y + ys)
		XDrawLine(dpy,xwin,gc,x,height-y,x+xm,height-y-ym);
	XDrawLine(dpy,xwin,gc,x,height-y,x1,height-y1);
	return 1;
} 

int draw_broken_line(Canvas canvas,int x0,int x1,int y0,int y1) /* draw single line */
{
	if (x0 == x1 && y0 == y1)
		draw_point(canvas,x0,y0);
	else if (x0 != x1 && y0 == y1)
		draw_horizontal_broken_line(canvas,x0,x1,y0);
	else if (x0 == x1 && y0 != y1)
		draw_vertical_broken_line(canvas,x0,y0,y1);
	else
		draw_slanted_broken_line(canvas,x0,x1,y0,y1);

	return 1;
}

int set_canvas_grid(Canvas canvas,int wx0,int wx1,int wxs,int wy0,int wy1,int wys,int fg) 
{
	Frame frame;
	Xv_Window pw;
	Display  *dpy;
	Window  xwin;
	Xv_xrectlist *xrects;
	int height,i,j,ni,nj;
	GC gc;

	pw = canvas_paint_window(canvas);
	xwin = (Window)xv_get(canvas_paint_window(canvas),XV_XID);
	frame = (Frame)xv_get(canvas, XV_OWNER);
	dpy = (Display *)xv_get(frame, XV_DISPLAY);
	xrects = (Xv_xrectlist *)xv_get(canvas,CANVAS_VIEWABLE_RECT,pw);
	gc = DefaultGC(dpy, DefaultScreen(dpy));
	height = (int) xv_get(canvas, CANVAS_HEIGHT);
	for (i = wx0; i <= wx1; i = i + wxs)
	    if (fg == 1)
		XDrawLine(dpy,xwin,gc,i,height-wy0,i,height-wy1);
	    else
		XDrawLine(dpy,xwin,gc,i,wy0,i,wy1);
	for (j = wy0; j <= wy1; j = j + wys)
	    if (fg == 1)
		XDrawLine(dpy,xwin,gc,wx0,height-j,wx1,height-j);
	    else
		XDrawLine(dpy,xwin,gc,wx0,j,wx1,j);
	return 1;
} 

void clear_canvas(Canvas canvas,int width,int height)
{
	Frame frame;
	Display  *dpy;
	Window  xwin;

	frame = (Frame)xv_get(canvas, XV_OWNER);	
	xwin = (Window)xv_get(canvas_paint_window(canvas),XV_XID);
	dpy = (Display *)xv_get(frame, XV_DISPLAY);
	XClearArea(dpy,xwin,0,0,width,height,NULL);
}
int set_text_label(Canvas canvas,int x,int y,char * str)
{
	Frame frame;
	Xv_Window pw;
	Display  *dpy;
	Window  xwin;
	Xv_xrectlist *xrects;
	int height;
	unsigned int len;
	GC gc;

	pw = canvas_paint_window(canvas);
	xwin = (Window)xv_get(canvas_paint_window(canvas),XV_XID);
	frame = (Frame)xv_get(canvas, XV_OWNER);
	dpy = (Display *)xv_get(frame, XV_DISPLAY);
	xrects = (Xv_xrectlist *)xv_get(canvas,CANVAS_VIEWABLE_RECT,pw);
	gc = DefaultGC(dpy, DefaultScreen(dpy));
	height = (int) xv_get(canvas, CANVAS_HEIGHT);
	y = height - y;

	len = strlen(str);
	XClearArea(dpy,xwin,x,y-10,FONT_DX*len,FONT_DY,False);
	XDrawString(dpy,xwin,gc,x,y,str,len);
//      XFlush(dpy);    // added by dj for testing
	return 1;
} 

/* date */

# include <ctype.h>
# include <time.h>
# include <sys/types.h>
# include <sys/time.h>  // 6/96 dj

char* get_date()
{
        struct tm *tm;
        long tb;
	string str;

        tb = time((long *)NULL);
        tm = localtime(&tb);
        sprintf (str,"%2d/%d/%2d",tm->tm_mon+1,tm->tm_mday,tm->tm_year);

	return str;
}

/* window dumps */

int save_pixwin_to_raster_from_win(Frame frame,string fname)
{
	int pid;
	string xwd_cmd,fr_name;

	strcpy(fr_name,(char* ) xv_get(frame,XV_LABEL));

	sprintf(xwd_cmd,"nsl_xwd -out %s -name %s -frame",fname,fr_name);
	if ((pid = fork()) == 0)
	{
		execl("/bin/csh","csh","-c",xwd_cmd,(char*)0);
		perror("execl");
	}

	return 1;
} 


int save_pixwin_to_raster(Frame frame,string fname,int flag)
{
	int fg;

/*	if (flag == 1)
		fg = save_pixwin_to_raster_from_file(frame,fname);
	else
*/		fg = save_pixwin_to_raster_from_win(frame,fname);

	return fg;
}

int save_pixwin_to_postscript_from_win(Frame frame,char * fname,char * model_name,char * str)
{
	int pid;
	string fr_name;
	char xpr_cmd[250];
	char* display;

/* 	'-display display' as modifier to nsl_xwd */
/*	display = getenv("DISPLAY");
	printf("DISPLAY: %s",display);
*/
	string header,trailer,h0,h1;

	strcpy(fr_name,(char* ) xv_get(frame,XV_LABEL));

	sprintf(h0,"%s,file:%s",get_date(),fname);
	sprintf(h1,",model:%s,frame:%s",model_name,fr_name);
	sprintf(header,"-header %s%s",h0,h1);

	if (str != NULL && str[0] != '\0')
	  sprintf(trailer,"-trailer %s",str);
	else
	  strcpy(trailer," ");

	sprintf(xpr_cmd,"nsl_xwd -name %s -frame | nsl_xps %s %s > %s",fr_name,header,trailer,fname); 
	if ((pid = fork()) == 0)
	{
		execl("/bin/csh","csh","-c",xpr_cmd,(char*)0); 
		perror("execl");
	}
	return 1;
} 
int save_pixwin_to_postscript_from_file(Frame frame,char * fname)
{
	string str,ras_cmd;
	string rm_cmd;
	int pid;
	static index = 0;

	++index;
	sprintf(str,"/tmp/nsl_tmp_ps%d",index); 
	sprintf(rm_cmd,"unalias rm\n rm %s",str);

	if (save_pixwin_to_raster_from_file(frame,str) == 0)
	   return 0;

	sprintf(ras_cmd,"nsl_xps_rv %s > %s; %s",str,fname,rm_cmd);

	if ((pid = fork()) == 0)
	{
		execl("/bin/csh","csh","-c",ras_cmd,(char *) 0);
		perror("execl");
	}

	return 1;
}
int save_pixwin_to_postscript(Frame frame,char * fname,int flag,char * model_name,char * str)
{
	int fg;

/*	if (flag == 1)
	   fg = save_pixwin_to_postscript_from_file(frame,fname);
	else
*/	   fg = save_pixwin_to_postscript_from_win(frame,fname,model_name,str);

	return fg;
}
int save_pixwin_to_printer_from_win(Frame frame,char * model_name,char * str)
{
	int pid;
	string fr_name;
	char cmd_str[250];
	string header,trailer,h0,h1;

	strcpy(fr_name,(char* ) xv_get(frame,XV_LABEL));

	sprintf(h0,"%s",get_date());
	sprintf(h1,",model:%s,frame:%s",model_name,fr_name);
	sprintf(header,"-header %s%s",h0,h1);

	if (str != NULL && str[0] != '\0')
	  sprintf(trailer,"-trailer %s",str);
	else
	  strcpy(trailer," ");

	sprintf(cmd_str," nsl_xwd -name %s -frame | nsl_xps %s %s | nsl_lpr",fr_name,header,trailer);
	if ((pid = fork()) == 0)
	{
            execl("/bin/csh","csh","-c",cmd_str,(char *) 0);
	    perror("execl");
	}
	return 1;
} 

int file_to_printer(char * fname,int type)
{
	int pid;
	char ras_cmd[250];
	char rm_cmd[100];

	sprintf(rm_cmd,"unalias rm\n rm %s",fname);

	switch (type)
	{
	case 1: 	/* ras */
	    sprintf(ras_cmd,"nsl_xps_rv %s | nsl_lpr; %s",fname,rm_cmd);
	    break;
	case 2:  	/* ps */
	    sprintf(ras_cmd,"nsl_lpr %s; %s",fname,rm_cmd);
	    break;
	}

	if ((pid = fork()) == 0)
	{
            execl("/bin/csh","csh","-c",ras_cmd,(char *) 0);
	    perror("execl");
	}

	return 1;
} 


int save_pixwin_to_printer_from_file(Frame frame)
{
	string str,str1;
	static index = 0;

	++index;
	sprintf(str,"/tmp/nsl_tmp_pr%d",index); 

	if (save_pixwin_to_raster_from_file(frame,str) == 0)
		return 0;
	file_to_printer(str,1);

	return 1;
}


int save_pixwin_to_printer(Frame frame,int flag,char * model_name,char * str)
{
	int fg;

/*	if (flag == 1)
		fg = save_pixwin_to_printer_from_file(frame);
	else
*/		fg = save_pixwin_to_printer_from_win(frame,model_name,str);

	return fg;
}


















