/**************************************************************/
/*                                                            */
/*              	 nsl_command_print.c                 */
/*                                                            */
/* by Alfredo Weitzenfeld 				      */
/*                                                            */
/**************************************************************/

# include "nsl_command.h"

void nsl_help_print() // status help on the system
{
	cout << "\nprint 'type' ['option']\n";
	cout << "\n";
	cout << "print data information for object type\n";
	cout << "\n";
	cout << "    type    \t  option  \t    description\n";
	cout << "------------\t----------\t-------------------\n";
	cout << "\n";
	cout << "data_value\t\t\tcurrent layer data values\n";
	cout << "\t\t'name'\t\tcurrent layer data values by name\n";
	cout << "\t\t'index'\t\tcurrent layer data values by index\n";
	cout << "\n";
	cout << "- 'name' is either a string name or 'ALL'\n";
	cout << "- 'index' is an integer\n";
}
int nsl_print_command(istream& in_file)
{
	string str1,str2,str3;
	int status = 1;
	int index;

	if (nsl_get_str(in_file,str1) == 0)
	{
		nsl_help_print();
		return 1;
	}

	set_global_pointers();

	if (strcmp(str1,"data_value") == 0)
	{
	    if (nsl_get_str(in_file,str2) == 0)
		NSL_LAYER->print(LOG_STREAM);
	    else if ((index = atoi(str2)) != 0)
		NSL_MODEL->print_layer_data(LOG_STREAM,index);
	    else if (strcmp("ALL",str2) == 0)
		NSL_MODEL->print_all_layer_data(LOG_STREAM);
	    else
		NSL_MODEL->print_layer_data(LOG_STREAM,str2);
	}
	else
	{
		cmd_error("*** print command ***");
		cmd_error("unknown modifier: ",str1);
//		status = 1;
	}

	return status;
}
