/**************************************************************/
/*                                                            */
/*              	 nsl_command_reset.c                  */
/*                                                            */
/* by Alfredo Weitzenfeld 				      */
/*                                                            */
/**************************************************************/

# include "nsl_command.h"
# include <xview/server.h>
// the following two lines added by dj 3-13-96
# include "sun_winds.h"
Cms    cms;
Xv_Server server;
int reset_input_stim_list(nsl_layer* layer)
{
	int status=1,type;

    	if (layer != NULL)
    	{
	   type = layer->get_layer_type();
	   switch (type)
	   {
	   case 1:
	   	((nsl_input_data*) layer)->clear_stim();
		break;
	   case 2:
	   	((nsl_input_vector*) layer)->clear_stim();
		break;
	   case 3:
	   	((nsl_input_matrix*) layer)->clear_stim();
		break;
	   default:
		cmd_out("Unknown input_layer_type",type);
	   }
   	}
	else
		cmd_error("Unknown input layer");

	return status;
}
int reset_window_interface(window_interface* win_interface)
{
	int status=1;
 
	if (win_interface != NULL)
	{
//		panel_X0 = 0; 	// panel init location
//		panel_Y0 = 120; // panel init location
		delete win_interface;
	}
	if ((win_interface = new window_interface()) == NULL)
	{
		cmd_error("Cannot create new Window Interface");
		status = -1;
	}
	else
	{
	    if (NSL_SYSTEM->get_server_fg() == 0)
	    {
		int* argc = NSL_SYSTEM->get_argc_ptr();
		char** argv = NSL_SYSTEM->get_argv_ptr();
// the next line will make nsl crash if remote display access is not allowed
		server = xv_init(XV_INIT_ARGC_PTR_ARGV,argc,argv,NULL);
		NSL_SYSTEM->set_server_fg(1);
//added by dj
		              xv_set(server, SERVER_SYNC, TRUE, NULL);
// added temporary by dj.
				cms = (Cms)xv_create(NULL, CMS, CMS_SIZE, 2,

                               CMS_NAMED_COLORS, "white", "black",
                               NULL, NULL);
	    }
	}

	return status;
}
void nsl_help_reset()
{
	cout << "\nreset 'type'\n";
	cout << "\n";
	cout << "reset object type\n";
	cout << "\n";
	cout << "    type    \t    description\n";
	cout << "------------\t-------------------\n";
	cout << "\n";
	cout << "stim_list\t\treset stimuli list\n";
	cout << "window_interface\treset window interface\n";
}
int nsl_reset_command(istream& in_file)
{
	int status = 1;
	string str1,str2;

	if (nsl_get_str(in_file,str1) == 0)
	{
		nsl_help_reset();
		return 1;
	}

	set_global_pointers();

	if (strcmp(str1,"stim_list") == 0)
	{
		status = reset_input_stim_list(NSL_INPUT_LAYER);
	}
	else if (strcmp(str1,"window_interface") == 0)
	{
		status = reset_window_interface(NSL_INTERFACE);
	}
	else
		cmd_error("Unknown Modifier: ",str1);

	return status;
}











