//
//	nsl_matrix.c
//
// 96-1-26 aa: added a lot of   int i;  int j;

# include "nsl.h"
# include "nsl_headers.h"

extern nsl_model* NSL_MODEL;

nsl_matrix::nsl_matrix() : (3)
{
	i0 = 0;
	i1 = 0;
	j0 = 0;
	j1 = 0;
	imax = 0;
	jmax = 0;
	v = (num_type**) 0;
}
int nsl_matrix::alloc_mem(int s1, int s2)
{
  int i;
  int j;
	if (s1 <= 0 || s2 <= 0)
	{
		cmd_error("*** nsl_matrix::nsl_matrix ***");
		cmd_error("Exit with the following status");
		cmd_error("name: ",name);
		cmd_error("s1: ",s1);
		cmd_error("s2: ",s2);
		cmd_error_exit("Cannot create matrix");
	}
	i0 = 0; j0 = 0;
	i1 = s1-1; j1 = s2-1;
	imax = s1; jmax = s2;

	v = new num_type*[s1];

	for ( i = 0; i < s1; i++) //int took away by dj 2-5-96
		v[i] = new num_type[s2];
	
	for (i = 0; i < s1; i++)
	   for ( j = 0; j < s2; j++)
		v[i][j] = 0;

	return 1;
}

// nsl_matrix constructors

nsl_matrix::nsl_matrix(int s1, int s2) : (3)
{
  int i;
  int j;
	if (s1 <= 0 || s2 <= 0)
	{
		cmd_error("*** nsl_matrix::nsl_matrix ***");
		cmd_error("Exit with the following status");
		cmd_error("name: ",name);
		cmd_error("s1: ",s1);
		cmd_error("s2: ",s2);
		cmd_error_exit("Cannot create matrix");
	}
	i0 = 0; j0 = 0;
	i1 = s1-1; j1 = s2-1;
	imax = s1; jmax = s2;

	v = new num_type*[s1];

	for ( i = 0; i < s1; i++)
		v[i] = new num_type[s2];
	
	for (i = 0; i < s1; i++)
	   for ( j = 0; j < s2; j++)
		v[i][j] = 0;
}
nsl_matrix::nsl_matrix(nsl_matrix& a) : (3)
{
  int i;
  int j;
        int s1 = a.get_imax();
        int s2 = a.get_jmax();

        i0 = 0; j0 = 0;
        i1 = s1-1; j1 = s2-1;
        imax = s1; jmax = s2;

        v = new num_type*[s1];

        for ( i = 0; i < s1; i++)
                v[i] = new num_type[s2];

        for (i = 0; i < s1; i++)
           for ( j = 0; j < s2; j++)
                v[i][j] = a.v[i][j];
}
nsl_matrix::nsl_matrix(nsl_model* model,char* str,int s1, int s2) : (str,3)
{
  int i;
  int j;
  if (s1 <= 0 || s2 <= 0)
	{
		cmd_error("*** nsl_matrix::nsl_matrix ***");
		cmd_error("Exit with the following status");
		cmd_error("name: ",name);
		cmd_error("s1: ",s1);
		cmd_error("s2: ",s2);
		cmd_error_exit("Cannot create matrix");
	}
	i0 = 0; j0 = 0;
	i1 = s1-1; j1 = s2-1;
	imax = s1; jmax = s2;

	v = new num_type*[s1];

	for ( i = 0; i < s1; i++)
		v[i] = new num_type[s2];
	
	for (i = 0; i < s1; i++)
	   for ( j = 0; j < s2; j++)
		v[i][j] = 0;

	model->add_layer(this);
}
nsl_matrix::nsl_matrix(nsl_model& model,char* str,int s1, int s2) : (str,3)
{
  int i;
  int j;
	if (s1 <= 0 || s2 <= 0)
	{
		cmd_error("*** nsl_matrix::nsl_matrix ***");
		cmd_error("Exit with the following status");
		cmd_error("name: ",name);
		cmd_error("s1: ",s1);
		cmd_error("s2: ",s2);
		cmd_error_exit("Cannot create matrix");
	}
	i0 = 0; j0 = 0;
	i1 = s1-1; j1 = s2-1;
	imax = s1; jmax = s2;

	v = new num_type*[s1];

	for ( i = 0; i < s1; i++)
		v[i] = new num_type[s2];
	
	for (i = 0; i < s1; i++)
	   for ( j = 0; j < s2; j++)
		v[i][j] = 0;

	model.add_layer(this);
}
nsl_matrix::nsl_matrix(char* str,int s1,int s2) : (str,3)
{
  int i;
  int j;
	if (s1 <= 0 || s2 <= 0)
	{
		cmd_error("*** nsl_matrix::nsl_matrix ***");
		cmd_error("Exit with the following status");
		cmd_error("name: ",name);
		cmd_error("s1: ",s1);
		cmd_error("s2: ",s2);
		cmd_error_exit("Cannot create matrix");
	}
	i0 = 0; j0 = 0;
	i1 = s1-1; j1 = s2-1;
	imax = s1; jmax = s2;

	v = new num_type*[s1];

	for ( i = 0; i < s1; i++)
		v[i] = new num_type[s2];
	
	for (i = 0; i < s1; i++)
	   for ( j = 0; j < s2; j++)
		v[i][j] = 0;

	NSL_MODEL->add_layer(this);
}

// nsl_matrix destructors

nsl_matrix::~nsl_matrix()
{
  int i;
  int j;
	for ( i = 0; i < get_imax(); i++)
		delete v[i];

	delete v;
}

// nsl_matrix element w/ cmd_error checking

num_type& nsl_matrix::elem(int i, int j)
{
	if ((i < 0 || imax <= i) || (j < 0 || jmax <= j))
	{
		cmd_error("*** nsl_matrix::elem ***");
		cmd_error("Exit with the following status");
		cmd_error("name: ",name);
		cmd_error("i: ",i);
		cmd_error("j: ",j);
		cmd_error_exit("Matrix index out of range");
	}

	return (num_type&) v[i][j];
}

// matrix assignment

void nsl_matrix::operator=(nsl_matrix& a)
{
  int i;
  int j;
	if (a.imax != imax || a.jmax != jmax)
	{
		cmd_error("*** nsl_matrix::operator= ***");
		cmd_error("Exit with the following status");
		a.print_status(cerr);
		this->print_status(cerr);
		cmd_error_exit("Inconsistent matrix sizes");
	}

	if (able_fg == 0)
		return;

	for ( i = 0; i < imax; i++)
	   for ( j = 0; j < jmax; j++)
		v[i][j] = a.v[i][j];
}
void nsl_matrix::operator=(nsl_data& a)
{
  int i;
  int j;
	int imax = get_imax();  
	int jmax = get_jmax();

	if (able_fg == 0)
		return;

	num_type val = a.get_value();

	for ( i = 0; i < imax; i++)
	   for ( j = 0; j < jmax; j++)
		v[i][j] = val;
}
/*
void nsl_matrix::operator=(num_type** a) // no boundary checking
{
  int i;
  int j;
	if (able_fg == 0)
		return;

	for ( i = 0; i < imax; i++)
	   for ( j = 0; j < jmax; j++)
		v[i][j] = a[i][j];
}
*/
void nsl_matrix::operator=(num_type a)
{
	int imax = get_imax();
	int jmax = get_jmax();

	if (able_fg == 0)
		return;

	for (int i = 0; i < imax; i++)
	   for (int j = 0; j < jmax; j++)
		v[i][j] = a;
}

// matrix addition

nsl_matrix operator+(nsl_matrix& a)
{
	int aimax = a.get_imax();
	int ajmax = a.get_jmax();

	nsl_matrix c(aimax,ajmax);

	for (int i = 0; i < aimax; i++)
	   for (int j = 0; j < ajmax; j++)
		c.v[i][j] = a.v[i][j];

	return c;
}
nsl_matrix operator+(nsl_matrix& a,nsl_matrix& b)
{
	int aimax = a.get_imax();
	int ajmax = a.get_jmax();
	int bimax = b.get_imax();
	int bjmax = b.get_jmax();

	if (aimax != bimax || ajmax != bjmax)
	{
		cmd_error("*** nsl_matrix::operator+ ***");
		cmd_error("Exit with the following status");
		a.print_status(cerr);
		b.print_status(cerr);
		cmd_error_exit("Inconsistent matrix sizes");
	}

	nsl_matrix c(aimax,ajmax);

	for (int i = 0; i < aimax; i++)
	   for (int j = 0; j < ajmax; j++)
		c.v[i][j] = a.v[i][j] + b.v[i][j];

	return c;
}
nsl_matrix operator+(nsl_matrix& a,num_type b)
{
	int aimax = a.get_imax();
	int ajmax = a.get_jmax();

	nsl_matrix c(aimax,ajmax);

	for (int i = 0; i < aimax; i++)
	   for (int j = 0; j < ajmax; j++)
		c.v[i][j] = a.v[i][j] + b;

	return c;
}
nsl_matrix operator+(num_type a, nsl_matrix& b)
{
	int bimax = b.get_imax();
	int bjmax = b.get_jmax();

	nsl_matrix c(bimax,bjmax);

	for (int i = 0; i < bimax; i++)
	   for (int j = 0; j < bjmax; j++)
		c.v[i][j] = a + b.v[i][j];

	return c;
}
nsl_matrix operator+(nsl_matrix& a,nsl_data& b)
{
	int aimax = a.get_imax();
	int ajmax = a.get_jmax();

	nsl_matrix c(aimax,ajmax);

	for (int i = 0; i < aimax; i++)
	   for (int j = 0; j < ajmax; j++)
		c.v[i][j] = a.v[i][j] + b.v;

	return c;
}
nsl_matrix operator+(nsl_data& a, nsl_matrix& b)
{
	int bimax = b.get_imax();
	int bjmax = b.get_jmax();

	nsl_matrix c(bimax,bjmax);

	for (int i = 0; i < bimax; i++)
	   for (int j = 0; j < bjmax; j++)
		c.v[i][j] = a.v + b.v[i][j];

	return c;
}

// matrix subtruction

nsl_matrix operator-(nsl_matrix& a)
{
	int aimax = a.get_imax();
	int ajmax = a.get_jmax();

	nsl_matrix c(aimax,ajmax);

	for (int i = 0; i < aimax; i++)
	   for (int j = 0; j < ajmax; j++)
		c.v[i][j] = -a.v[i][j];

	return c;
}
nsl_matrix operator-(nsl_matrix& a,nsl_matrix& b)
{
	int aimax = a.get_imax();
	int ajmax = a.get_jmax();
	int bimax = b.get_imax();
	int bjmax = b.get_jmax();

	if (aimax != bimax || ajmax != bjmax)
	{
		cmd_error("*** nsl_matrix::operator- ***");
		cmd_error("Exit with the following status");
		a.print_status(cerr);
		b.print_status(cerr);
		cmd_error_exit("Inconsistent matrix sizes");
	}

	nsl_matrix c(aimax,ajmax);

	for (int i = 0; i < aimax; i++)
	   for (int j = 0; j < ajmax; j++)
		c.v[i][j] = a.v[i][j] - b.v[i][j];

	return c;
}
nsl_matrix operator-(nsl_matrix& a,num_type b)
{
	int aimax = a.get_imax();
	int ajmax = a.get_jmax();

	nsl_matrix c(aimax,ajmax);

	for (int i = 0; i < aimax; i++)
	   for (int j = 0; j < ajmax; j++)
		c.v[i][j] = a.v[i][j] - b;

	return c;
}
nsl_matrix operator-(num_type a, nsl_matrix& b)
{
	int bimax = b.get_imax();
	int bjmax = b.get_jmax();

	nsl_matrix c(bimax,bjmax);

	for (int i = 0; i < bimax; i++)
	   for (int j = 0; j < bjmax; j++)
		c.v[i][j] = a - b.v[i][j];

	return c;
}
nsl_matrix operator-(nsl_matrix& a,nsl_data& b)
{
	int aimax = a.get_imax();
	int ajmax = a.get_jmax();

	nsl_matrix c(aimax,ajmax);

	for (int i = 0; i < aimax; i++)
	   for (int j = 0; j < ajmax; j++)
		c.v[i][j] = a.v[i][j] - b.v;

	return c;
}
nsl_matrix operator-(nsl_data& a, nsl_matrix& b)
{
	int bimax = b.get_imax();
	int bjmax = b.get_jmax();

	nsl_matrix c(bimax,bjmax);

	for (int i = 0; i < bimax; i++)
	   for (int j = 0; j < bjmax; j++)
		c.v[i][j] = a.v - b.v[i][j];

	return c;
}

// matrix pointwise multiplication

nsl_matrix operator^(nsl_matrix& a,nsl_matrix& b)
{
	int aimax = a.get_imax();
	int ajmax = a.get_jmax();
	int bimax = b.get_imax();
	int bjmax = b.get_jmax();

	if (aimax != bimax || ajmax != bjmax)
	{
		cmd_error("*** nsl_matrix::operator^ ***");
		cmd_error("Exit with the following status");
		a.print_status(cerr);
		b.print_status(cerr);
		cmd_error_exit("Inconsistent matrix sizes");
	}

	nsl_matrix c(aimax,ajmax);

	for (int i = 0; i < aimax; i++)
	   for (int j = 0; j < ajmax; j++)
		c.v[i][j] = a.v[i][j] * b.v[i][j];

	return c;
}
nsl_matrix operator^(nsl_matrix& a,num_type b)
{
	int aimax = a.get_imax();
	int ajmax = a.get_jmax();

	nsl_matrix c(aimax,ajmax);

	for (int i = 0; i < aimax; i++)
	   for (int j = 0; j < ajmax; j++)
		c.v[i][j] = a.v[i][j] * b;

	return c;
}
nsl_matrix operator^(num_type a, nsl_matrix& b)
{
	int bimax = b.get_imax();
	int bjmax = b.get_jmax();

	nsl_matrix c(bimax,bjmax);

	for (int i = 0; i < bimax; i++)
	   for (int j = 0; j < bjmax; j++)
		c.v[i][j] = a * b.v[i][j];

	return c;
}
nsl_matrix operator^(nsl_matrix& a,nsl_data& b)
{
	int aimax = a.get_imax();
	int ajmax = a.get_jmax();

	nsl_matrix c(aimax,ajmax);

	for (int i = 0; i < aimax; i++)
	   for (int j = 0; j < ajmax; j++)
		c.v[i][j] = a.v[i][j] * b.v;

	return c;
}
nsl_matrix operator^(nsl_data& a, nsl_matrix& b)
{
	int bimax = b.get_imax();
	int bjmax = b.get_jmax();

	nsl_matrix c(bimax,bjmax);

	for (int i = 0; i < bimax; i++)
	   for (int j = 0; j < bjmax; j++)
		c.v[i][j] = a.v * b.v[i][j];

	return c;
}

// matrix convolution

nsl_matrix operator*(nsl_matrix& a,nsl_matrix& b)
{
	int saimax = a.get_imax();
	int sajmax = a.get_jmax();
	int sbimax = b.get_imax();
	int sbjmax = b.get_jmax();

	int simax = saimax + sbimax - 1;
	int sjmax = sajmax + sbjmax - 1;

	nsl_matrix c(sbimax,sbjmax);
	nsl_matrix d(simax,sjmax);

	d = d.put_sector(b,saimax/2,sajmax/2); 

	for (int i = 0; i < sbimax; i++)
	   for (int j = 0; j < sbjmax; j++)
	   {	
		num_type val = (num_type) 0;
		for (int m = 0; m < saimax; m++)
		   for (int n = 0; n < sajmax; n++)
			val = val + a.v[m][n] * d.v[i+m][j+n];
		c.v[i][j] = val;
	   }

	return c;
}
nsl_matrix operator*(nsl_vector& a,nsl_matrix& b) // row,col vector
{
	int saimax = a.get_imax();
	int sbimax = b.get_imax();
	int sbjmax = b.get_jmax();

	int vec_type;
	int simax;
	int m;
	num_type val = 0;

	nsl_matrix c(sbimax,sbjmax);

	if ((vec_type = a.get_vec_type()) == 0)
	{
		simax = saimax + sbjmax - 1;
		nsl_matrix d(sbimax,simax);
		d = d.put_sector(b,0,saimax/2); 

		for (int i = 0; i < sbimax; i++)
		   for (int j = 0; j < sbjmax; j++)
		   {	
			val = 0;	
			for (m = 0; m < saimax; m++)
			    val = val + a.v[m] * d.v[i][j+m];
			c.v[i][j] = val;
		   }
	}
	else
	{
		simax = saimax + sbimax - 1;
		nsl_matrix d(simax,sbjmax);
		d = d.put_sector(b,saimax/2,0); 

		for (int i = 0; i < sbimax; i++)
		   for (int j = 0; j < sbjmax; j++)
		   {	
			val = 0;
			for (m = 0; m < saimax; m++)
			    val = val + a.v[m] * d.v[i+m][j];
			c.v[i][j] = val;
		   }
	}

	return c;
}
nsl_matrix operator*(nsl_matrix& b,nsl_vector& a) // same as previous
{
	int saimax = a.get_imax();
	int sbimax = b.get_imax();
	int sbjmax = b.get_jmax();

	int vec_type;
	int simax;
	int m;
	num_type val = 0;

	nsl_matrix c(sbimax,sbjmax);

	if ((vec_type = a.get_vec_type()) == 0)
	{
		simax = saimax + sbjmax - 1;
		nsl_matrix d(sbimax,simax);
		d = d.put_sector(b,0,saimax/2); 

		for (int i = 0; i < sbimax; i++)
		   for (int j = 0; j < sbjmax; j++)
		   {	
			val = 0;	
			for (m = 0; m < saimax; m++)
			    val = val + a.v[m] * d.v[i][j+m];
			c.v[i][j] = val;
		   }
	}
	else
	{
		simax = saimax + sbimax - 1;
		nsl_matrix d(simax,sbjmax);
		d = d.put_sector(b,saimax/2,0); 

		for (int i = 0; i < sbimax; i++)
		   for (int j = 0; j < sbjmax; j++)
		   {	
			val = 0;
			for (m = 0; m < saimax; m++)
			    val = val + a.v[m] * d.v[i+m][j];
			c.v[i][j] = val;
		   }
	}

	return c;
}
nsl_matrix operator*(nsl_matrix& a,nsl_data& b)
{
	int aimax = a.get_imax();
	int ajmax = a.get_jmax();

	nsl_matrix c(aimax,ajmax);

	for (int i = 0; i < aimax; i++)
	   for (int j = 0; j < ajmax; j++)
		c.v[i][j] = a.v[i][j] * b.v;

	return c;
}
nsl_matrix operator*(nsl_data& a, nsl_matrix& b)
{
	int bimax = b.get_imax();
	int bjmax = b.get_jmax();

	nsl_matrix c(bimax,bjmax);

	for (int i = 0; i < bimax; i++)
	   for (int j = 0; j < bjmax; j++)
		c.v[i][j] = a.v * b.v[i][j];

	return c;
}
nsl_matrix operator*(nsl_matrix& a,num_type b)
{
	int aimax = a.get_imax();
	int ajmax = a.get_jmax();

	nsl_matrix c(aimax,ajmax);

	for (int i = 0; i < aimax; i++)
	   for (int j = 0; j < ajmax; j++)
		c.v[i][j] = a.v[i][j] * b;

	return c;
}
nsl_matrix operator*(num_type a, nsl_matrix& b)
{
	int bimax = b.get_imax();
	int bjmax = b.get_jmax();

	nsl_matrix c(bimax,bjmax);

	for (int i = 0; i < bimax; i++)
	   for (int j = 0; j < bjmax; j++)
		c.v[i][j] = a * b.v[i][j];

	return c;
}

// matrix pointwise division

nsl_matrix operator/(nsl_matrix& a,nsl_matrix& b)
{
	int aimax = a.get_imax();
	int ajmax = a.get_jmax();
	int bimax = b.get_imax();
	int bjmax = b.get_jmax();

	if (aimax != bimax || ajmax != bjmax)
	{
		cmd_error("*** nsl_matrix::operator/ ***");
		cmd_error("Exit with the following status");
		a.print_status(cerr);
		b.print_status(cerr);
		cmd_error_exit("Inconsistent matrix sizes");
	}

	nsl_matrix c(aimax,ajmax);

	for (int i = 0; i < aimax; i++)
	   for (int j = 0; j < ajmax; j++)
	   {
		if (b.v[i][j] == 0)
		{
			cmd_error("*** nsl_matrix::operator/ ***");
			cmd_error("Exit with the following status");
			b.print_status(cerr);
			b.print(cerr);
			cmd_error_exit("Division by zero");
		}
		c.v[i][j] = a.v[i][j] / b.v[i][j];
	   }

	return c;
}
nsl_matrix operator/(nsl_matrix& a,num_type b)
{
	if (b == 0)
	{
		cmd_error("*** nsl_matrix::operator/ ***");
		cmd_error("Exit with the following status");
		cmd_error("b: ",b);
		cmd_error_exit("Division by zero");
	}

	int aimax = a.get_imax();
	int ajmax = a.get_jmax();

	nsl_matrix c(aimax,ajmax);

	for (int i = 0; i < aimax; i++)
	   for (int j = 0; j < ajmax; j++)
		c.v[i][j] = a.v[i][j] / b;

	return c;
}
nsl_matrix operator/(num_type a, nsl_matrix& b)
{
	int bimax = b.get_imax();
	int bjmax = b.get_jmax();

	nsl_matrix c(bimax,bjmax);

	for (int i = 0; i < bimax; i++)
	   for (int j = 0; j < bjmax; j++)
	   {
		if (b.v[i][j] == 0)
		{
			cmd_error("*** nsl_matrix::operator/ ***");
			cmd_error("Exit with the following status");
			b.print_status(cerr);
			b.print(cerr);
			cmd_error_exit("Division by zero");
		}
		c.v[i][j] = a / b.v[i][j];
	   }

	return c;
}
nsl_matrix operator/(nsl_matrix& a,nsl_data& b)
{
	if (b.v == 0)
	{
		cmd_error("*** nsl_matrix::operator/ ***");
		cmd_error("Exit with the following status");
		b.print_status(cerr);
		b.print(cerr);
		cmd_error_exit("Division by zero");
	}

	int aimax = a.get_imax();
	int ajmax = a.get_jmax();

	nsl_matrix c(aimax,ajmax);

	for (int i = 0; i < aimax; i++)
	   for (int j = 0; j < ajmax; j++)
		c.v[i][j] = a.v[i][j] / b.v;

	return c;
}
nsl_matrix operator/(nsl_data& a, nsl_matrix& b)
{
	int bimax = b.get_imax();
	int bjmax = b.get_jmax();

	nsl_matrix c(bimax,bjmax);

	for (int i = 0; i < bimax; i++)
	   for (int j = 0; j < bjmax; j++)
	   {
		if (b.v[i][j] == 0)
		{
			cmd_error("*** nsl_matrix::operator/ ***");
			cmd_error("Exit with the following status");
			b.print_status(cerr);
			b.print(cerr);
			cmd_error_exit("Division by zero");
		}
		c.v[i][j] = a.v / b.v[i][j];
	   }

	return c;
}

// min and max

num_type nsl_matrix::max()
{
	int simax = get_imax();
	int sjmax = get_jmax();

	num_type c = v[0][0];

	for (int i = 0; i < simax; i++)
	   for (int j = 0; j < sjmax; j++)
		if (v[i][j] > c)
			c = v[i][j];

	return c;
}
num_type nsl_matrix::min()
{
	int simax = get_imax();
	int sjmax = get_jmax();

	num_type c = v[0][0];

	for (int i = 0; i < simax; i++)
	   for (int j = 0; j < sjmax; j++)
		if (v[i][j] < c)
			c = v[i][j];

	return c;
}

// elemenet sum 

num_type nsl_matrix::sum()
{
	num_type c = 0;

	for (int i = 0; i < imax; i++)
	    for (int j = 0; j < jmax; j++)
		c = v[i][j] + c;

	return c;
}

// vector transformations

nsl_vector nsl_matrix::reduce_col()
{
	int simax = get_imax();
	int sjmax = get_jmax();

	nsl_vector c(simax);
	
	for (int j = 0; j < sjmax; j++)
	    for (int i = 0; i < simax; i++)
		c.v[i] = v[i][j] + c.v[i];

	return c;
}
nsl_vector nsl_matrix::reduce_row()
{
	int simax = get_imax();
	int sjmax = get_jmax();

	nsl_vector c(sjmax);
		
	for (int i = 0; i < simax; i++)
	   for (int j = 0; j < sjmax; j++)
		c.v[j] = v[i][j] + c.v[j];

	return c;
}

// matrix sector

nsl_matrix nsl_matrix::get_sector(int si0, int si1, int sj0, int sj1)
{
	if (si0 > si1 || sj0 > sj0 || si0 < 0 || sj0 < 0 || 
	    si1 > get_imax() || sj1 > get_jmax())
	    {
		cmd_error("*** nsl_matrix::get_sector ***");
		cmd_error("Exit with the following status");
		this->print_status(cerr);
		cmd_error("si0: ",si0);
		cmd_error("si1: ",si1);
		cmd_error("sj0: ",sj0);
		cmd_error("sj1: ",sj1);
		cmd_error_exit("Bad matrix sector");
	    }

	int simax = si1 - si0 + 1;
	int sjmax = sj1 - sj0 + 1;

	nsl_matrix c(simax,sjmax);

	for (int i = si0; i <= si1; i++)
	    for (int j = sj0; j <= sj1; j++)
		c.v[i-si0][j-sj0] = v[i][j]; 

	return c;
}
nsl_matrix nsl_matrix::set_sector(nsl_matrix& a, int si0, int sj0)
{
	if (si0 < 0 || sj0 < 0)
	{
		cmd_error("*** nsl_matrix::set_sector ***");
		cmd_error("Exit with the following status");
		a.print_status(cerr);
		this->print_status(cerr);
		cmd_error("i0: ",si0);
		cmd_error("j0: ",sj0);
		cmd_error_exit("Bad matrix sector");
	}

	int saimax = a.get_imax();
	int sajmax = a.get_jmax();
	int simax = get_imax();
	int sjmax = get_jmax();

	nsl_matrix c(simax,sjmax);

	int scimax = (saimax < simax) ? saimax : simax;
	int scjmax = (sajmax < sjmax) ? sajmax : sjmax;

	c = (*this);

	for (int i = 0; i < scimax; i++)
	    for (int j = 0; j < scjmax; j++)
		c.v[i+si0][j+sj0] = a.v[i][j]; 

	return c;
}
nsl_matrix nsl_matrix::put_sector(nsl_matrix& a, int si0, int sj0)
{
	return set_sector(a,si0,sj0);
}
nsl_vector nsl_matrix::get_row(int i)
{
	if (i < 0 || imax <= i)
	{
		cmd_error("*** nsl_matrix::get_row ***");
		cmd_error("Exit with the following status");
		cmd_error("name: ",name);
		cmd_error("i: ",i);
		cmd_error_exit("Matrix row index out of range");
	}

	nsl_vector a(jmax);

	for (int j = 0; j < jmax; j++)
		a.elem(j) = v[i][j];

	return a;
}
nsl_vector nsl_matrix::get_col(int j)
{
	if (j < 0 || jmax <= j)
	{
		cmd_error("*** nsl_matrix::get_col ***");
		cmd_error("Exit with the following status");
		cmd_error("name: ",name);
		cmd_error("j: ",j);
		cmd_error_exit("Matrix col index out of range");
	}

	nsl_vector a(imax);

	for (int i = 0; i < imax; i++)
		a.elem(i) = v[i][j];

	return a;
}
nsl_matrix nsl_matrix::set_row(nsl_vector& a,int i)
{
	if (i < 0 || imax <= i || a.get_imax() != jmax)
	{
		cmd_error("*** nsl_matrix::set_row ***");
		cmd_error("Exit with the following status");
		cmd_error("name: ",name);
		cmd_error("i: ",i);
		cmd_error_exit("Matrix row index out of range");
	}

	nsl_matrix c(imax,jmax);

	c = (*this);

	for (int j = 0; j < jmax; j++)
		c.v[i][j] = a.elem(j);

	return c;
}
nsl_matrix nsl_matrix::set_col(nsl_vector& a,int j)
{
	if (j < 0 || jmax <= j || a.get_imax() != imax)
	{
		cmd_error("*** nsl_matrix::set_col ***");
		cmd_error("Exit with the following status");
		cmd_error("name: ",name);
		cmd_error("j: ",j);
		cmd_error_exit("Matrix row index out of range");
	}

	nsl_matrix c(imax,jmax);

	c = (*this);

	for (int i = 0; i < imax; i++)
		c.v[i][j] = a.elem(i);

	return c;
}

// stream

extern int nsl_get_str(istream&,char*);

ostream& operator<<(ostream& out,nsl_matrix& a)
{
	int imax = a.get_imax();
	int jmax = a.get_jmax();

	for (int i = 0; i < imax; i++)
	{
	    for (int j = 0; j < jmax; j++)
		out << a.v[i][j] << " ";
	    out << "\n";
	}

	return out;
}
istream& operator>>(istream& in,nsl_matrix& a)
{
	int imax = a.get_imax();
	int jmax = a.get_jmax();

	float v;
	string str;
	char* aptr[NAME_SIZE];
	char** ptr = aptr;

	for (int i = 0; in && i < imax; i++)
	    for (int j = 0; in && j < jmax; j++)
	    {
//		in >> a.v[i][j];

		// loop until some string is encountered on any line
		while (nsl_get_str(in,str) == 0)
		{
		    if (strcmp(str,"EOF") == 0) // check for EOF
		    {
			cmd_error("Not enough matrix input values");
			return in;
		    }
		}

		v = strtod(str,ptr); // similar to 'atof(str)' w/ error check

		if (strcmp(str,*ptr) == 0)
		{
		    cmd_error("Bad matrix input value: ",str);
		    return in;
		}
		else
		{
			a.v[i][j] = v;
		}
	    }

	return in;
}

// print matrix values

void nsl_matrix::print(ostream& out)
{
	out << "\n";
	out << "set data_value " << name << "\n";
	out << *this;
	out.flush();
}
void nsl_matrix::print(ostream& out,int si0, int si1, int sj0, int sj1)
{
	if (si0 > si1 || sj0 > sj1 || si0 < 0 || sj0 < 0 || 
	    si1 > get_imax() || sj1 > get_jmax())
	    {
		cmd_error("*** nsl_matrix::print ***");
		cmd_error("Exit with the following status");
		this->print_status(cerr);
		cmd_error("si0: ",si0);
		cmd_error("si1: ",si1);
		cmd_error("sj0: ",sj0);
		cmd_error("sj1: ",sj1);
		cmd_error("i0: ",i0);
		cmd_error("j0: ",j0);
		cmd_error("i1: ",i1);
		cmd_error("j1: ",j1);
		cmd_error_exit("Bad matrix sector");
	    }

	out << "\n// " << name << "\n";
	out << "set data_value " << name << "\n";
	for (int i = si0; i <= si1; i++)
	{
	    for (int j = sj0; j <= sj1; j++)
		out << v[i][j] << " "; 
	    out << "\n";
	}
	out.flush();
}

// print status

void nsl_matrix::print_layer_status(ostream& out)
{
	nsl_layer::print_layer_status(out);

	out << "// imax: " << imax << "\n";
	out << "// jmax: " << jmax << "\n";
	out << "// i0: " << i0 << "\n";
	out << "// i1: " << i1 << "\n";
	out << "// j0: " << j0 << "\n";
	out << "// j1: " << j1 << "\n";
	out.flush();
}
void nsl_matrix::print_status(ostream& out)
{
	print_layer_status(out);
}
































