//
//	spatial_graph_3.c
//

# include "nsl.h"
# include "nsl_headers.h"
# include "nsl_winds.h"
/*
extern "C" int plt3d(int,int,int,int,int,int,
	float,float,float,float,float,float,float,float);
extern "C" int old_d3ntrp(Canvas,int,int,num_type**,int,int,int,int);
extern "C" int new_d3ntrp(Canvas,int,int,num_type**,int,int,int,int);
*/

extern  int plt3d(int,int,int,int,int,int,
	float,float,float,float,float,float,float,float);
extern  int old_d3ntrp(Canvas,int,int,num_type**,int,int,int,int);
extern  int new_d3ntrp(Canvas,int,int,num_type**,int,int,int,int);

extern void set_menu_canvas_events(Canvas);

spatial_graph_3::spatial_graph_3(display_window* window)
	: display_graph(window,"spatial_graph_3")
{
	set_menu_canvas_events(canvas);
//	hidden_fg = 1;
	parent_canvas->set_clear_fg(1);
}
void spatial_graph_3::read_from_database()
{
	string str;

	display_graph::read_from_database();
	
	parent_window->get_general_data("hiddenfg",str);

	if (strcmp(str,"ON") == 0)
		hidden_fg = 1;
	else
		hidden_fg = 0;

	parent_window->get_general_data("sx",&sx);
	parent_window->get_general_data("sy",&sy);
	parent_window->get_general_data("sz",&sz);
	parent_window->get_general_data("ax",&ax);
	parent_window->get_general_data("by",&by);
	parent_window->get_general_data("cz",&cz);
}
void spatial_graph_3::write_to_database()
{
	display_graph::write_to_database();
}
void spatial_graph_3::input(int x_pos,int y_pos,int fg)
{
}
void spatial_graph_3::output(int x_pos,int y_pos)
{
}
void spatial_graph_3::display()
{
}
void spatial_graph_3::print(ostream& out)
{
	canvas_object::print(out);
}

// par
spatial_graph_3_par::spatial_graph_3_par(display_window* window,
	nsl_data* m) : spatial_graph_3(window)
{
	layer_ptr = m;
	layer0_ptr = m;
}
void spatial_graph_3_par::read_from_database()
{
	parent_window->set_win_sector(0,0,0,0,1,1); // update win sector
	spatial_graph_3::read_from_database(); // read in new win sector
}
void spatial_graph_3_par::write_to_database()
{
	spatial_graph_3::write_to_database();
}
void spatial_graph_3_par::display()
{
}
void spatial_graph_3_par::print(ostream& out)
{
	spatial_graph_3::print(out);
}

// vec
spatial_graph_3_vec::spatial_graph_3_vec(display_window* window,
	nsl_vector* m) : spatial_graph_3(window)
{
	layer_ptr = m;
	layer0_ptr = m;
}
void spatial_graph_3_vec::read_from_database()
{
	parent_window->get_general_data("i0",&i0);
	parent_window->get_general_data("i1",&i1);

	imax = ((nsl_vector*) layer_ptr)->get_imax();

	parent_window->get_general_data("vec_type",&vec_type);

	if (i0 < 0) 
	{
		i0 = 0;
		parent_window->set_general_data("i0",i0);
	}
	if (i1 > imax-1) 
	{
		i1 = imax-1;
		parent_window->set_general_data("i1",i1);
	}
	if (i1 < i0)
	{
		i0 = 0;
		i1 = imax-1;
		parent_window->set_general_data("i0",i0);
		parent_window->set_general_data("i1",i1);
	}

	if (vec_type == 0)
	   parent_window->set_win_sector(0,i0,0,i1,1,imax); // update win sector
	else
	   parent_window->set_win_sector(i0,0,i1,0,imax,1); // update win sector
	spatial_graph_3::read_from_database(); // read in new win sector
}
void spatial_graph_3_vec::write_to_database()
{
	spatial_graph_3::write_to_database();
}
void spatial_graph_3_vec::display()
{
	cmd_error("Unable to display vector spatial_graph_3");
}
void spatial_graph_3_vec::print(ostream& out)
{
	spatial_graph_3::print(out);
}

// mat
spatial_graph_3_mat::spatial_graph_3_mat(display_window* window,
	nsl_matrix* m) : spatial_graph_3(window)
{
	layer_ptr = m;
	layer0_ptr = m;
}
void spatial_graph_3_mat::read_from_database()
{
	parent_window->get_general_data("i0",&i0);
	parent_window->get_general_data("i1",&i1);
	parent_window->get_general_data("j0",&j0);
	parent_window->get_general_data("j1",&j1);

	imax = ((nsl_matrix*) layer_ptr)->get_imax();
	jmax = ((nsl_matrix*) layer_ptr)->get_jmax();

	if (i0 < 0) 
	{
		i0 = 0;
		parent_window->set_general_data("i0",i0);
	}
	if (i1 > imax-1) 
	{
		i1 = imax-1;
		parent_window->set_general_data("i1",i1);
	}
	if (i1 < i0)
	{
		i0 = 0;
		i1 = imax-1;
		parent_window->set_general_data("i0",i0);
		parent_window->set_general_data("i1",i1);
	}

	if (j0 < 0) 
	{
		j0 = 0;
		parent_window->set_general_data("j0",j0);
	}
	if (j1 > jmax-1) 
	{
		j1 = jmax-1;
		parent_window->set_general_data("j1",j1);
	}
	if (j1 < j0)
	{
		j0 = 0;
		j1 = jmax-1;
		parent_window->set_general_data("j0",j0);
		parent_window->set_general_data("j1",j1);
	}

	parent_window->set_win_sector(i0,j0,i1,j1,imax,jmax); // update win sector
	spatial_graph_3::read_from_database(); // read in new win sector
}
void spatial_graph_3_mat::write_to_database()
{
	spatial_graph_3::write_to_database();
}
void spatial_graph_3_mat::display()
{
	num_type** m = ((nsl_matrix*) layer_ptr)->get_matrix();

	int graph_x_mid = (wx1 - wx0)/2;
	int graph_y_mid = (wy1 - wy0)/2;

	int win_x_mid = graph_x_mid + wx0;
	int win_y_mid = graph_y_mid + wy0;

  	plt3d(graph_x_mid,graph_y_mid,i0,i1,j0,j1,ax,by,cz,sx,sy,sz,wymin,wymax);
	if (hidden_fg == 1)
		new_d3ntrp(canvas,win_x_mid,win_y_mid,m,i0,i1,j0,j1);
	else
		old_d3ntrp(canvas,win_x_mid,win_y_mid,m,i0,i1,j0,j1);
}
void spatial_graph_3_mat::print(ostream& out)
{
	spatial_graph_3::print(out);
}
